"use strict";
this.name        = "reversecontrol";
this.author      = "Norby";
this.copyright   = "2014 Norbert Nagy";
this.licence     = "CC BY-NC-SA 3.0";
this.description = "Reverse up-down control in the aft view.";
this.version     = "1.0";

//customizable properties
this.$ReverseControlOn = true; //can turn off without uninstall

//internal properties, should not touch
this.$ReverseControlFCB = null; //FrameCallBack
this.$ReverseControlPrevOri = null; //previous orientation

//world script events
this.startUp = function() {
	if( this.$ReverseControlOn && !isValidFrameCallback( this.$ReverseControlFCB ) )
		this.$ReverseControlFCB = addFrameCallback( this.$ReverseControl_FCB );
}

//ReverseControl methods
this.$ReverseControl_FCB = function( delta ) { //FrameCallBack
	var ps = player.ship;
	var r = worldScripts["reversecontrol"];

	if( ps && ps.isValid && !ps.docked && ps.viewDirection == "VIEW_AFT" ) {
		var prevori = r.$ReverseControlPrevOri;
		if( !prevori ) r.$ReverseControlPrevOri = player.ship.orientation;
		else {
			//reverse up-down
			var a = ps.heading.angleTo( prevori.vectorUp() ) - Math.PI / 2; //
			var c = prevori.vectorRight();
			ps.orientation = ps.orientation.rotate( c, 2 * a );
			//reverse roll
			var a = ps.orientation.vectorRight().angleTo( prevori.vectorUp() ) - Math.PI / 2; //
			var c = prevori.vectorForward();
			r.$ReverseControlPrevOri = ps.orientation = ps.orientation.rotate( c, -2 * a );
		}
	} else r.$ReverseControlPrevOri = null;
}